<template>
  <!-- Centered view -->
  <div class="lg:w-2/3 xl:w-1/2 w-full mx-auto pt-8 pb-16 px-4">

    <!-- Title -->
    <h1 class="text-center">{{ $t('views.Settings.Index.title') | capitalize }}</h1>

    <!-- Not confirmed email message -->
    <t-alert v-if="!this.$root.auth.user().emailVerifiedAt" class="mb-8 px-6 w-full" show>

      <p class="mb-4">{{ $t('user.emailNotVerifiedAlert') }}</p>

      <Button
        variant="primary"
        @click.native="resendEmailConfirmationLink"
      >
        <v-icon name="redo-alt"/> {{ $t('user.resendEmailConfirmationLink') | capitalize }}
      </Button>

    </t-alert>

    <!-- Tab view -->
    <TabView
      :tabs="{
        tab1: {
          title: $h.capitalize($t('views.Settings.Index.tabView.general'))
        },
        tab2: {
          title: $h.capitalize($t('views.Settings.Index.tabView.myAccount'))
        }
      }"
      stack="left"
    >

      <!-- General settings -->
      <template v-slot:tab1>

        <!-- Theme -->
        <div class="mb-4">
          <div class="mb-2">{{ $t('global.theme') | capitalize }} :</div>
          <ThemeDropdown />
        </div>

        <!-- Lang -->
        <div class="mb-4">
          <div class="mb-2">{{ $t('global.lang') | capitalize }} :</div>
          <LangDropdown />
        </div>

        <!-- App version -->
        <div class="mb-4">
          <div class="mb-2">{{ $t('global.appVersion') | capitalize }} :</div>
          <div class="w-min p-2 rounded bg-gray-100 dark:bg-dark-2">{{ GLOBALS.__UI_VERSION__ }}</div>
        </div>

      </template>

      <!-- Account settings -->
      <template v-slot:tab2>

        <!-- Thumbnail -->
        <div class="mb-4">
          <div class="mb-2">{{ $t('user.thumbnail') | capitalize }} :</div>
          <UserThumbnail
            :data="$root.auth.user().thumbnailBase64"
            :width="128"
          />
        </div>

        <!-- Firstname -->
        <div class="mb-4">
          <div class="mb-2">{{ $t('user.firstname') | capitalize }} :</div>
          <div class="p-2 rounded bg-gray-100 dark:bg-dark-2">{{ $root.auth.user().firstname }}</div>
        </div>

        <!-- Lastname -->
        <div class="mb-4">
          <div class="mb-2">{{ $t('user.lastname') | capitalize }} :</div>
          <div class="p-2 rounded bg-gray-100 dark:bg-dark-2">{{ $root.auth.user().lastname }}</div>
        </div>

        <!-- Email -->
        <div class="mb-4">
          <div class="mb-2">{{ $t('user.email') | capitalize }} :</div>
          <div class="p-2 rounded bg-gray-100 dark:bg-dark-2">{{ $root.auth.user().email }}</div>
        </div>

        <!-- Created at -->
        <div class="mb-4">
          <div class="mb-2">{{ $t('user.accountCreatedAt') | capitalize }} :</div>
          <div class="p-2 rounded bg-gray-100 dark:bg-dark-2">{{ createdAt }}</div>
        </div>

        <!-- Last login -->
        <div class="mb-6">
          <div class="mb-2">{{ $t('user.lastLogin') | capitalize }} :</div>
          <div class="p-2 rounded bg-gray-100 dark:bg-dark-2">{{ lastLogin }}</div>
        </div>

        <!-- Edit button -->
        <Button variant="primary" :to="`/settings/edit-account`">
          <v-icon name="pen"/> {{ $t('global.modify') | capitalize }}
        </Button>

      </template>

    </TabView>

  </div>
</template>

<script>
// vuex helpers
import { mapActions } from 'vuex'
/**
 * Settings component
 */
export default {
  name: 'Settings',
  computed: {
    /**
     * Created at
     */
    createdAt: function () {
      return this.$i18n.locale === 'fr'
        ? this.$h.dateFormat(this.$root.auth.user().createdAt, 'dd/mm/yyyy HH:MM')
        : this.$h.dateFormat(this.$root.auth.user().createdAt, 'yyyy/mm/dd HH:MM')
    },
    /**
     * Last login
     */
    lastLogin: function () {
      return this.$i18n.locale === 'fr'
        ? this.$h.dateFormat(this.$root.auth.user().lastLogin, 'dd/mm/yyyy HH:MM')
        : this.$h.dateFormat(this.$root.auth.user().lastLogin, 'yyyy/mm/dd HH:MM')
    }
  },
  methods: {
    // Map actions from 'Users' store module
    ...mapActions('Users', [
      'resendEmailVerificationLink'
    ]),
    /**
     * Handle click on 'resend email link' button.
     * @param {Object} evt - The event payload
     * @returns {void}
     */
    async resendEmailConfirmationLink (evt) {
      evt.preventDefault()
      // Wait for resendEmailVerificationLink function
      const response = await this.resendEmailVerificationLink({ userId: this.$root.auth.user().id })
      // If passed
      if (!(response instanceof Error)) {
        // Show popup
        this.$store.commit('SET_SYSTEM_SHOW_EMAIL_SENT_MODAL', true)
      // Else parse server error
      } else {
        this.throwSystemError(this.$t('errors.e0010'))
      }
    }
  }
}
</script>
